package org.silex.core;

#if js
import js.Dom;
#end

#if php
import org.silex.htmlGenerator.InterpreterContext;
#end

class Utils
{
	public static function getTarget(source_mc : Dynamic, path_str : String, ?separator : String)
	{
		//untyped console.log("getTarget");
		if (path_str == null || path_str == "" || path_str == "." )
			return source_mc;

		// Choose the first clip : source_mc or silex or silexGabaritRoot or layout root
		var tmp_source_mc : Dynamic = null;

		// default separator = "."
		if (separator == null) separator=".";

		// get a path array from the path string
		var path_array:Array<String>=path_str.split(separator);
		
		var firstInPathArray:String = path_array[0];
		//_global.getSilex(this).utils.alert("path_str : " + path_str + ", firstInPathArray : " + firstInPathArray);		
		switch(firstInPathArray)
		{
			case "_global":
				#if js
				tmp_source_mc = js.Lib.window;
				#end
				#if php
				tmp_source_mc = InterpreterContext.components;
				#end
				path_array.shift();
			case "_root":
				#if js
				tmp_source_mc = js.Lib.window;
				#end
				#if php
				tmp_source_mc = InterpreterContext.components;
				#end
				path_array.shift();
			case "silex":
				#if js
				tmp_source_mc = js.Lib.window;
				#end
				#if php
				tmp_source_mc = InterpreterContext.components;
				#end
				path_array.shift();
			case "layout":
				#if js
				tmp_source_mc = js.Lib.window;
				#end
				#if php
				tmp_source_mc = InterpreterContext.components;
				#end
				path_array.shift();
			case "plugins":
				#if js
				tmp_source_mc = js.Lib.window;
				#end
				#if php
				tmp_source_mc = InterpreterContext.components;
				#end
				path_array.shift();
			default:
				#if js
				var playerTmp = js.Lib.document.getElementById(firstInPathArray);
				#end
				#if php
				var playerTmp = InterpreterContext.components.get(firstInPathArray);
				#end
				if (playerTmp != null){
					tmp_source_mc = playerTmp;
					path_array.shift();
				}else if (Reflect.field(source_mc, firstInPathArray) != null){ // source_mc
					// start looking for the target in the source object
					tmp_source_mc = source_mc;
				}
				#if js
				else if(elementHasChildId(source_mc, firstInPathArray) != null)
				{
					tmp_source_mc = source_mc;
				}
				#end
				else
				{
					tmp_source_mc = source_mc;
				}
		}			
				// reach the targeted clip
				for(i in 0...path_array.length){
					switch(path_array[i])
					{
						case "_x":
							#if js
							return Std.string(Std.parseFloat(untyped tmp_source_mc.style.left));
							#end
						case "_y":
							#if js
							return Std.string(Std.parseFloat(untyped tmp_source_mc.style.top));
							#end
						default:
							//Are we in a Hash? If yes use Hash's get function
							if(Std.is(tmp_source_mc, Hash))
							{
								tmp_source_mc = tmp_source_mc.get(path_array[i]);
							} else
							{
								//Is it a property of the object?
								if (Reflect.field(tmp_source_mc, path_array[i]) != null)
									tmp_source_mc=Reflect.field(tmp_source_mc, path_array[i]);
								#if js
								else if(elementHasChildId(tmp_source_mc, path_array[i]) != null){
									tmp_source_mc = elementHasChildId(tmp_source_mc, path_array[i]);
								}
								#end
								else
								{
									return null;
								}
							}
					}
				}

				return tmp_source_mc;
	}
	
	#if js
	private static function elementHasChildId(element : HtmlDom, id : String)
	{
		//untyped console.log("elementHasChildId");
		for(i in 0...element.childNodes.length)
		{
			if(element.childNodes[i].id == id)
			{
				return element.childNodes[i];
			}
		}
		
		return null;
	}
	#end
	
	public static function revealAccessors(input_str : String, source_mc : Dynamic, ?separator : String) : Dynamic
	{
		// _array is used to store the string splited on "((" and "))" for text that should be removed if the accessor has no value
		var _array:Array<String>;
		// temp index
		var idx:Int;
		// flag used to determine the return value type (string, object or array of objects
		var hasStringInIt:Bool=false;
		// default separator = "."
		if (separator==null) separator=".";

		// **
		// check input
		if (input_str==null)
		{
			// error in the input
			// throw new Error("org.silex.core.Utils  revealAccessors - error in the input argument, input_str is not a String: "+input_str);
			return "";
		}
		if (!Std.is(input_str, String))
		{
			input_str = input_str.toString();
		}
		
		// split on ((
		_array = splitTags(input_str, "((", "))");
		
		
		// **
		// replaces accessors by data on each element
		for (idx in 0..._array.length)
		{
			var ltgt_length_num:Int=2; // length of "<<" and ">>"
			var start_idx:Int=_array[idx].indexOf("<<");
			// against html encoding bug
			if (start_idx==-1)
			{
				ltgt_length_num=8;// length of "<<" and ">>"
				start_idx=_array[idx].indexOf((">>"));
			}
			// it has no << so it is a string
			if (start_idx == -1)
				hasStringInIt = true;

			// if there is no accessor, leave the "((" and "))"
			// there was a "((" and "))" pair only if we are not on a pair index // the first or last array element
			if (start_idx==-1 && idx%2!=0)//idx!=0 && idx!=_array.length-1)
			{
				_array[idx] = "((" + _array[idx] + "))";
			}

			// for each accessor found in this element
			while (start_idx>=0)
			{
				ltgt_length_num=2;// length of "<<" and ">>"
				var end_idx:Int=_array[idx].indexOf(">>");
				// against html encoding bug
				if (end_idx==-1) 
				{
					ltgt_length_num=8;// length of "<<" and ">>"
					end_idx=_array[idx].indexOf(">>");
				}

				// no ">>" to close the "<<"
				if (end_idx <= start_idx) break; 

				// get the accessor name
				var accessor_name:String=_array[idx].substr(start_idx+ltgt_length_num,end_idx-(start_idx+ltgt_length_num));

				// retrieve the filter name
				var hasFilter:Bool = false;
				var filter_name:String;
				var args:Array<String>;
				var filter_separator_index:Int = accessor_name.indexOf(",");
				if (filter_separator_index > 0)
				{
					// retrieve the filter name and args, e.g. "filter:arg1,arg2" in <<filter:arg1,arg2 accessor>>
					filter_name = accessor_name.substr(0, filter_separator_index);
					// retrieve the arguments, e.g. ["filter","arg1,arg2"] in <<filter:arg1,arg2 accessor>>
					var argsArray = filter_name.split(":");
					// update filter name, e.g. "filter" in <<filter:arg1,arg2 accessor>>
					filter_name = argsArray[0];
					// retrieve the arguments, e.g. ["arg1","arg2"] in <<filter:arg1,arg2 accessor>>
					args = argsArray[1].split(",");
					// retrieve the accessor itself, e.g. "accessor" in <<filter:arg1,arg2 accessor>>
					accessor_name = accessor_name.substr(filter_separator_index + 1);
				}


				// get the corresponding value
				var value_obj:Dynamic=getTarget(source_mc,accessor_name,separator);

				// filter value
				//**TODO** : Implement filters
				/*
				if (silex_ptr.filter.filterExist(filter_name,value_obj,args,source_mc))
				{
					value_obj = silex_ptr.filter.exec(filter_name,value_obj,args,source_mc);
				}
				*/

				// is there a value?
				if (value_obj!=null)
				{// yes, there is a value
					// retrieve value
					var value_str:String;
					if (!Std.is(value_obj, String))
					{
						// filter value
/*						if (silex_ptr.filter.filterExist(filter_name,value_obj,args,source_mc))
						{
							_array[idx] = silex_ptr.filter.exec(filter_name,value_obj,args,source_mc);
						}
						*/
						_array[idx] = value_obj;
						break;
					}
					else
					{
						if(Std.is(value_obj, String))
						{
							// return value will be string
							hasStringInIt = true;

							value_str = value_obj.toString();

							// replace the accessor in the element by the value
							_array[idx]=
								_array[idx].substr(0,start_idx)
								+ value_str
								+ _array[idx].substr(end_idx + ltgt_length_num);
						}
						else
						{
							_array[idx] = value_obj;
							break;
						}
					}
				}
				else
				{// no, there is no value
					// remove all the text between "((" and "))"
					_array[idx] = ""; 
					hasStringInIt = true;
				}
				// loop: next accessor (next "<<")
				ltgt_length_num=2;// length of "<<" and ">>"
				start_idx=_array[idx].indexOf("<<");
				// against html encoding bug
				if (start_idx==-1) 
				{
					ltgt_length_num=8;// length of "<<" and ">>"
					start_idx=_array[idx].indexOf((">>"));
				}
			}
		}
		
		var res : Dynamic;
		if (hasStringInIt == true)
		{
			// return value is string
			res = _array.join("");
		}
		else if (_array.length>1)
		{
			// return value is array of objects
			res = _array;
		}
		else
		{
			// return value is an object
			res = _array[0];
		}
		return res;
	}
	
	public static function splitTags(input_str : String, leftTag: String, rightTag : String) : Array<String>
	{
		// default values
		if (leftTag == null) leftTag = "((";
		if (rightTag == null) rightTag = "))";

		// tmp_array is used to store the string splited on "((" for text that should be removed if the accessor has no value
		var tmp_array:Array<String>;

		// result array
		var _array:Array<String>=new Array<String>();

		// **
		// split on ((
		tmp_array=input_str.split("((");
		
		// split on ))
		for(idx in 0...tmp_array.length)
		{
			if (tmp_array[idx] != "")
			{
				var tmp_idx:Int=tmp_array[idx].indexOf("))");
				if (tmp_idx!=null && tmp_idx>=0)
				{// bug : when no "))" is found, tmp_idx=undefined
					//_array.push(tmp_array[idx].slice(0,tmp_idx));
					_array.push(tmp_array[idx].substr(0,tmp_idx+1));
					if (tmp_idx+2<tmp_array[idx].length)
						_array.push(tmp_array[idx].substr(tmp_idx+2));
				}
				else
					_array.push(tmp_array[idx]);
			}
		}
		
		return _array;
	}
}