/*This file is part of Silex - see http://projects.silexlabs.org/?/silex

Silex is © 2010-2011 Silex Labs and is released under the GPL License:

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License (GPL) as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
package org.silex.htmlGenerator;
import org.silex.publication.LayerModel;
import org.silex.publication.SubLayerModel;

/**
*  This class represents a SubLayer for the HTML5Generator.
*/
class SubLayer 
{
	//Holds all initializedComponents that are part of this SubLayer.
	public var initializedComponents : Array<{componentInstance : Dynamic, componentModel : org.silex.publication.ComponentModel}>;
	public var subLayerName : String;
	public var layerName : String;
	
	public function new()
	{
		initializedComponents = new Array<{componentInstance : Dynamic, componentModel : org.silex.publication.ComponentModel}>();
		subLayerName = "";
		layerName = "";
	}
	
	/**
	*  Returns the HTML wrapping code for a subLayer.
	*/
	public function returnHTML()
	{
		var html : String;
		html = '<div class="SILEXsubLayer" id="' + this.layerName + '-' + this.subLayerName + '" style="position:absolute;left:0px;top:0px">';
		
		//Do rendering of components
		for(component in initializedComponents)
		{
			try
			{
				html += component.componentInstance.getHTML();
			} catch(e : Dynamic)
			{
				throw component.componentInstance.playerName + " " + Std.string(e);
			}
		}
		
		html += "</div>";
		return html;
	}
}