package org.silex.htmlGenerator;

import org.silex.ui.UiBase;

class Utils
{
	public static var deeplink : Deeplink;
	public static var siteEditor : org.silex.serverApi.SiteEditor;
	
	private static var cssRules = new Hash<String>();
	
	/**
	*  Adds a CSS rule with the specified selector and the specified content
	*/
	public static function addCssRule(selector : String, content : String) : Void
	{
		cssRules.set(selector, content);
	}
	
	/**
	*  Removes the CSS rule with the specified selector.
	*/
	public static function removeCssRule(selector : String) : Void
	{
		cssRules.remove(selector);
	}
	
	/**
	*  Returns the content of the specified rule.
	*/
	public static function getCssRule(selector : String) : Null<String>
	{
		return cssRules.get(selector);
	}
	
	/**
	*  Returns the CSS code for all rules.
	*/
	public static function getCssText() : String
	{
		var cssCode : String;
		cssCode = "";
		
		for(selector in cssRules.keys())
		{
			cssCode += selector + " {\n";
			cssCode += cssRules.get(selector) + "\n";
			cssCode += "}\n\n";
		}
		
		return cssCode;
	}
	
	/**
	*  Returns true if the specified icon is the one selected
	*/
	public static function isSelectedIcon(icon : UiBase) : Bool
	{
		if(php.Web.getParams().get("selectedIcon") != null)
		{
			if(untyped icon.__silex__layerPath__.join(".") + "." + icon.playerName  == php.Web.getParams().get("selectedIcon"))
			{
				return true;
			}
		}
		
		return false;
	}
}